Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/preprocess_visibility.env
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/preprocess_visibility.env	(revision 1216)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/preprocess_visibility.env	(revision 1746)
@@ -6,49 +6,57 @@
 Scene {
 
-# filename ../data/glasgow/glasgow1.x3d
-#	filename vienna.x3d
-# filename ../data/vienna/vienna-simple.x3d
-#filename ../data/vienna/vienna-buildings.x3d
-#filename ../data/vienna/vienna-buildings.x3d;../data/vienna/vienna-roofs.x3d;../data/vienna/vienna-plane.x3d;../data/vienna/vienna-roads.x3d
-# filename ../data/vienna/viewcells-25-sel.x3d
-#filename ../data/atlanta/atlanta2.x3d
-filename ../data/soda/soda.dat
+filename ../data/vienna/vienna_cropped.obj
+#filename ../data/soda/soda.dat
 #filename ../data/soda/soda5.dat
-#filename ../data/PowerPlant/ppsection1/part_a/g0.ply
-#filename ../data/PowerPlant/ppsection1/part_b/g0.ply
-#filename ../data/PowerPlant/ppsection1.plb
-#filename ../data/PowerPlant/all.plb
-#filename ../data/PowerPlant/selection3.plb
-#filename ../data/PowerPlant/section10.plb;../data/PowerPlant/section14.plb
-#filename ../data/PowerPlant/selection.plb
-#filename ../data/PowerPlant/comps/ppsection1/comps.plb
 }
 
 Preprocessor {
+	delayVisibilityComputation false
 	# stored sample rays
 	samplesFilename rays.out
 	useGlRenderer false
 	useGlDebugger false
+# 0 = INTERNAL 		1 = MLRT
+
+	rayCastMethod 0
+	
 #	type sampling
 #	type vss
 	type rss
 #	type render
-	detectEmptyViewSpace false
+	detectEmptyViewSpace true
 	pvsRenderErrorSamples 0
-#	pvsRenderErrorSamples 1000
 	quitOnFinish true
 	computeVisibility true
-	applyVisibilityFilter	false
-	applyVisibilitySpatialFilter	true
+	applyVisibilityFilter false
+	applyVisibilitySpatialFilter false
 	visibilityFilterWidth	0.01
+	exportVisibility true
 	visibilityFile visibility.xml
-}
-
+	loadMeshes false
+	loadKdTree	false
+	exportKdTree false
+}
+
+ObjParser {
+	meshGrouping 2
+}
+
+RenderSampler {
+	samples 10000
+}
+
+
+SamplingPreprocessor {
+	totalSamples 100000000
+	samplesPerPass 1000000
+}
 
 RssPreprocessor {
-	samplesPerPass 1000000
-	initialSamples 1000000
-	vssSamples 5000000
-	vssSamplesPerPass 1000000
+	samplesPerPass 1000
+	initialSamples 2000000
+	vssSamples 100000000
+#	vssSamples 1000000
+	vssSamplesPerPass 3000000
 	useImportanceSampling true
 
@@ -60,5 +68,5 @@
 		rssTree false
 		rays false
-		numRays 20000
+		numRays 2000
 	}
 
@@ -69,11 +77,10 @@
 }
 
-
 RssTree {
 	epsilon		1e-6
 	perObjectTree false
 
-	maxDepth 	40
-	minPvs		3
+	maxDepth 	60
+	minPvs		1
 # before vienna test it was:
 #	minRays	50
@@ -83,13 +90,15 @@
 	minSize		0.001
  	maxCostRatio 1.0
-	maxRayContribution 0.5
-	maxRays		2000000
+	maxRayContribution 1.0
+	maxRays		3000000
 	maxTotalMemory	200
 	maxStaticMemory	100
 
-	splitType regular
+#	splitType regular
 #	splitType heuristic
-#	splitType hybrid
+	splitType hybrid
+	hybridDepth		10
 	splitUseOnlyDrivingAxis false
+#false
 	importanceBasedCost false
 
@@ -140,22 +149,18 @@
 
 
-
 ViewCells {
 	# samples used for view cell construction
 	Construction {
-		samples 100000
-		samplesPerPass 100000
-	}
-
-	Filter {
-		maxSize 5
-		width  0.05
+		samples 0
+		samplesPerPass 1500000
 	}
 
 	#number of active view cells
-	active 5000
+	active 20000
+	maxViewCells 20000
+
 	maxStaticMemory	40
 
-	exportToFile false
+	exportToFile true
 	loadFromFile true
 
@@ -163,24 +168,23 @@
 	#type vspKdTree
 	#type bspTree
-	type vspBspTree
+	#type vspBspTree
+	type vspOspTree
 	#type sceneDependent
 	
 	height 5.0
-	maxViewCells 5000
 
 	#percentage of total visible objects where pvs is considered invalid
 	maxPvsRatio 1.0
 		
-	pruneEmptyViewCells false
 	processOnlyValidViewCells false
 
 	#stats viewCellStats.log
 
-	samplingType directional
-	#samplingType box
+	#samplingType directional
+	samplingType box
 
 	PostProcess {
 		# how much samples are used for post processing
-		samples 100000
+		samples 0
 		renderCostWeight 1.0
 		maxCostRatio 0.1
@@ -189,5 +193,4 @@
 		maxMergesPerPass 5000
 		useRaysForMerge false
-		refine false
 		compress false
 		merge false
@@ -196,5 +199,5 @@
 	Visualization {
 		# how much samples we use for visualization
-		samples 100000
+		samples 0
 		#colorCode PVS
 		#colorCode MergedLeaves
@@ -202,33 +205,27 @@
 		colorCode Random
 		exportRays false
-		exportGeometry false
+		exportGeometry true
 		exportMergedViewCells false
 		useClipPlane true
 		clipPlaneAxis 1
-	}
-
-	showVisualization false	
+		clipPlanePos  0.3
+	}
+
+	showVisualization false
 	evaluateViewCells false
 	
 	Evaluation {
-		samplesPerPass 500
-		samples 1000
+		samplesPerPass 1000000
+		samples 5000000
 		statsPrefix ../scripts/viewCells
-	}
-
-#	filename ../data/atlanta/atlanta_viewcells_large.x3d
-#	filename ../data/vienna/viewcells-25-sel.x3d
-#	filename ../data/vienna/viewcells-25.x3d
-#	filename ../data/vienna/viewcells-large-sel.x3d
-#	filename ../scripts/viewcells_vienna.xml
-#	filename ../scripts/viewcells_atlanta.xml
-#	filename ../scripts/viewcells_soda5-2.xml
-#	filename ../data/soda/soda5-viewcells.xml
-#	filename ../scripts/viewcells_atlanta.xml
-#	filename ../data/soda/soda5-viewcells2.xml
-	filename ../data/atlanta/viewcells_atlanta3.xml
-#	filename ../data/vienna/viewcells_vienna.xml
-#	filename ../data/PowerPlant/power_plant_viewcells_all3.xml
-}
+		#samplingType directional
+		samplingType box
+		histogram true
+		histoStepSize 5000
+	}
+
+	filename ../data/vienna/vienna_cropped-gradient-viewcells.xml.gz
+}
+
 
 
@@ -239,42 +236,2 @@
 	moveSpeed 0.0001
 }
-
-
-VspKdTree {
-	epsilon		1e-6
-
-	Construction {
-		samples 500000
-	}
-	
-	Termination {
-		maxDepth	 	40
-		minPvs			0
-		minRays			1
-		minSize			0.001
-		maxCostRatio		5.9
-		maxViewCells		169
-		missTolerance		4
-		maxRayContribution 	2.5
-	}
-	
-	maxTotalMemory	100
-	maxStaticMemory	40
-
-	splitType 	regular
-	#splitType 	heuristics
-	splitUseOnlyDrivingAxis true
-	ct_div_ci	0.0
-	
-	# maximal cost for merging a view cell
-	PostProcess {
-		maxCostRatio 0.005
-		minViewCells 10000
-		maxPvsSize   5000
-	}
-	
-	
-	Visualization {
-	}
-}
-
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/generate_viewcells.env
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/generate_viewcells.env	(revision 1745)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/generate_viewcells.env	(revision 1746)
@@ -40,4 +40,6 @@
 	exportKdTree false 
 #	exportObj true
+	applyVisibilityFilter false
+	applyVisibilitySpatialFilter false
 }
 
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/preprocess_visibility.sh
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/preprocess_visibility.sh	(revision 1746)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/preprocess_visibility.sh	(revision 1746)
@@ -0,0 +1,17 @@
+#!/bin/sh
+
+PREPROCESSOR=../bin/release/preprocessor.exe
+
+if [ $# -ne 3 ]
+then
+    echo "Usage:"
+	echo "preprocess_visibility scene_file.x3d viewcells_file.xml output_file.xml"
+    exit
+fi
+
+export PATH=$PATH:../bin
+
+NUM_SAMPLE_RAYS=5000000
+
+$PREPROCESSOR -rss_vss_samples=$NUM_SAMPLE_RAYS \
+-scene_filename=$1 -view_cells_filename=$2 -preprocessor_visibility_file=$3 preprocess_visibility.env 
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/preprocess_visibility
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/preprocess_visibility	(revision 1455)
+++ 	(revision )
@@ -1,17 +1,0 @@
-#!/bin/sh
-
-PREPROCESSOR=../bin/release/preprocessor.exe
-
-if [ $# -ne 3 ]
-then
-    echo "Usage:"
-	echo "preprocess_visibility scene_file.x3d viewcells_file.xml output_file.xml"
-    exit
-fi
-
-export PATH=$PATH:../bin
-
-NUM_SAMPLE_RAYS=5000000
-
-$PREPROCESSOR -rss_vss_samples=$NUM_SAMPLE_RAYS \
--scene_filename=$1 -view_cells_filename=$2 -preprocessor_visibility_file=$3 preprocess_visibility.env 