Index: GTP/trunk/Lib/Vis/Preprocessing/work/plots/showplot
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/work/plots/showplot	(revision 1754)
+++ GTP/trunk/Lib/Vis/Preprocessing/work/plots/showplot	(revision 1754)
@@ -0,0 +1,5 @@
+#!/bin/sh
+mv plot.fig $1.fig
+fig2dev -L eps $1.fig $1.eps
+#gv -scale 3 $1.eps &
+gv $1.eps &
Index: GTP/trunk/Lib/Vis/Preprocessing/work/plots/plot_sampling
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/work/plots/plot_sampling	(revision 1754)
+++ GTP/trunk/Lib/Vis/Preprocessing/work/plots/plot_sampling	(revision 1754)
@@ -0,0 +1,71 @@
+#!/bin/sh
+
+PREFIX=osp-rss
+#PREFIX=atlanta2-rss9
+#PREFIX=vienna-rss8
+#PREFIX=atlanta-e
+#PREFIX=wien-e
+#PREFIX=random-e
+    
+
+#COMMAND1=../cmxplot
+COMMAND1=./ps_memory_plot
+COMMAND2=./ps_memory_plot2
+COMMAND3=./ps_memory_plot3
+
+
+#$PREFIX-l.log \
+
+#FILES="\
+#$PREFIX-e1.log \
+#$PREFIX-e2.log \
+#"
+
+FILES="`ls $PREFIX*.log`"
+#FILES="../../src/stats.log"
+#FILES="../../src/stats.log"
+#FILES="soda5-rss4-i-combined-b3.log soda5-rss4-i-combined-update-b3.log soda5-rss4-r-spatial-based-b3.log soda5-rss4-r-object-based-b3.log ../../src/stats.log"
+#FILES="atlanta-50.log atlanta-new-10.log"
+#FILES="soda5-50.log soda5-new-10.log soda5-new-50.log soda5-new-20.log"
+#FILES="soda-100M-1.log soda-100M-2.log soda-100M-3.log"
+#FILES="atlanta-50M-1.log"
+#FILES="soda-rss-r2.log soda-rss-i2.log soda-rss-i3.log soda-rss-r3-spatial-based.log soda-rss-r4-direction-based.log"
+#FILES="soda-rss3-r-object-based.log soda-rss3-r-direction-based.log soda-rss3-i-combined.log"
+
+#FILES="atlanta2-rss1-i-combined.log atlanta2-rss1-i-combined-update.log atlanta2-rss1-r-spatial-based.log"
+
+#FILES="soda5-rss2-i-combined.log soda5-rss2-i-combined2.log soda5-rss2-i-combined3.log soda5-rss2-i-combined4.log soda5-rss2-i-combined5.log soda5-rss2-i-combined6.log soda5-rss2-i-combined7.log soda5-rss2-i-combined8.log soda5-rss2-r-spatial-based.log"
+
+#FILES="soda5-rss3-i-combined.log soda5-rss3-i-combined2.log soda5-rss3-i-combined3.log soda5-rss3-i-combined-update.log soda5-rss3-i-combined-update2.log soda5-rss3-r-object-based.log"
+
+#FILES="soda-rss3-i-combined.log soda-rss3-i-combined-update.log soda-rss3-i-combined-update2.log soda-rss3-i-combined-update3.log soda-rss3-i-combined-update4.log soda-rss3-i-combined-update5.log ../../src/stats.log soda-rss3-r-object-based.log"
+# soda-rss3-r-object-based2.log"
+
+#../../src/stats.log
+
+echo $FILES
+
+STYLE=lines
+
+#$COMMAND1 $STYLE ViewCellId TotalTime $FILES
+#./showplot $PREFIX-totaltime.eps
+
+#$COMMAND1 $STYLE ViewCellId BuildOcclusionMapTime $FILES
+#./showplot plot.eps $PREFIX-build.eps
+
+#$COMMAND1 points ViewCellPerimeter NumVisibleObjects $FILES
+#./showplot plot.eps $PREFIX-percellvisobj.eps
+
+#$COMMAND1 $STYLE ViewCellId ClassifyVisibilityTime $FILES
+#./showplot plot.eps $PREFIX-vistime.eps
+
+
+#$COMMAND1 $STYLE ViewCellId NumVisibleOccluders $FILES
+#./showplot $PREFIX-visobj.eps
+
+$COMMAND2 $STYLE TotalSamples AVG_PVS $FILES
+./showplot $PREFIX-avgpvs
+
+$COMMAND2 $STYLE Time AVG_PVS $FILES
+./showplot $PREFIX-avgpvstime
+
Index: GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot	(revision 1754)
+++ GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot	(revision 1754)
@@ -0,0 +1,58 @@
+#!/bin/sh
+#unalias rm
+
+rm -f *.tmpplot*
+
+PFILE=plot.fig
+FILE=tmp.plot
+echo $FILE
+rm -f $FILE
+#echo set term postscript eps monochrome dashed \"Times-Roman\" 24 > $FILE
+echo set term fig color fontsize 22 big landscape > $FILE
+#echo set term postscript eps color solid > $FILE
+echo set output \"$PFILE\" >> $FILE
+#echo set term x11 > $FILE
+#echo set grid >> $FILE 
+STYLE=$1
+echo set xlabel \"$2\" >> $FILE 
+echo set ylabel \"$3\" >> $FILE
+# echo set boxwidth 0.4 >> $FILE
+
+echo set logscale y >> $FILE
+echo -n plot >> $FILE
+
+#echo -n " " 2*x*log\(x\)  title \"O\(k log k\)\" with lines" , " >>$FILE
+
+PAR1=$2
+PAR2=$3
+NAME=A
+
+shift
+shift
+shift    
+for i in $* ; do
+    echo $i ;
+    echo $NAME
+    grep -A 1 $PAR1 $i | grep -v "\-\-" | grep -v "#" > $i.tmpplot.x ;
+    grep -A 1 $PAR2 $i | grep -v "\-\-" | grep -v "#" > $i.tmpplot.y ;
+    paste $i.tmpplot.x $i.tmpplot.y > $i.tmpplot ;
+    if test $i != $1 ; then echo -n ", ">>$FILE; fi
+    echo -n " "\"$i.tmpplot\"  title \"$NAME\" with $STYLE" " >>$FILE ;
+    YPLOT="$YPLOT $i.tmpplot.y";
+    case $NAME in
+    A) NAME=B;;
+    B) NAME=C;;
+    C) NAME=D;;
+    D) NAME=E;;
+    E) NAME=F;;
+    F) NAME=G;;
+    esac;
+done ;
+echo >> $FILE
+paste $1.tmpplot.x $YPLOT | grep -v "#"
+
+cat $FILE
+gnuplot $FILE 
+rm -f $FILE
+rm -f *.tmpplot*
+
Index: GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot2
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot2	(revision 1754)
+++ GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot2	(revision 1754)
@@ -0,0 +1,66 @@
+#!/bin/sh
+unalias rm
+
+rm -f *.tmpplot*
+
+PFILE=plot.fig
+FILE=tmp.plot
+echo $FILE
+rm -f $FILE
+#echo set term postscript eps monochrome dashed \"Times-Roman\" 24 > $FILE
+#echo set term postscript eps color solid > $FILE
+echo set term fig color fontsize 10 big landscape > $FILE
+echo set output \"$PFILE\" >> $FILE
+
+
+#echo set term x11 > $FILE
+#echo set grid >> $FILE 
+STYLE=$1
+echo set xlabel \"$2\" >> $FILE 
+echo set ylabel \"$3\" >> $FILE
+#echo set yrange \[0:100\] >> $FILE
+
+# echo set boxwidth 0.4 >> $FILE
+
+#echo set logscale x >> $FILE
+echo -n plot >> $FILE
+
+
+PAR1=$2
+PAR2=$3
+NAME=A
+
+shift
+shift
+shift    
+
+pt=1
+lt=1
+
+for i in $* ; do
+    echo $i ;
+    echo $NAME
+    grep -A 1 $PAR1 $i | grep -v "\-\-" | grep -v "#" > $i.tmpplot.x ;
+    grep -A 1 $PAR2 $i | grep -v "\-\-" | grep -v "#" > $i.tmpplot.y ;
+    paste $i.tmpplot.x $i.tmpplot.y > $i.tmpplot ;
+    if test $i != $1 ; then echo -n ", ">>$FILE; fi
+    echo -n " "\"$i.tmpplot\"  title \"$NAME\" with $STYLE" " lt $pt >>$FILE ;
+    YPLOT="$YPLOT $i.tmpplot.y";
+    case $NAME in
+    A) NAME=B;;
+    B) NAME=C;;
+    C) NAME=D;;
+    D) NAME=E;;
+    E) NAME=F;;
+    F) NAME=G;;
+    esac;
+    let pt=$pt+1;
+done ;
+echo >> $FILE
+paste $1.tmpplot.x $YPLOT | grep -v "#"
+
+cat $FILE
+gnuplot $FILE 
+rm -f $FILE
+rm -f *.tmpplot*
+
Index: GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot3
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot3	(revision 1754)
+++ GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot3	(revision 1754)
@@ -0,0 +1,69 @@
+#!/bin/sh
+unalias rm
+
+rm -f *.tmpplot*
+
+PFILE=plot.fig
+FILE=tmp.plot
+echo $FILE
+rm -f $FILE
+#echo set term postscript eps monochrome dashed \"Times-Roman\" 24 > $FILE
+#echo set term postscript eps color solid > $FILE
+echo set term fig color fontsize 18 big  > $FILE
+echo set output \"$PFILE\" >> $FILE
+
+
+#echo set term x11 > $FILE
+#echo set grid >> $FILE 
+STYLE=$1
+echo set xlabel \"$2\" >> $FILE 
+echo set ylabel \"$3\" >> $FILE
+echo set yrange \[1:1e8\] >> $FILE
+
+#echo set boxwidth 0.4 >> $FILE
+
+echo set logscale xy >> $FILE
+echo -n plot >> $FILE
+
+echo -n " " x*x*x*x*x*x*x*log\(x\)  title \"O\(k^2 log k\)\" with lines" , " >>$FILE
+
+PAR1=$2
+PAR2=$3
+NAME=A
+
+shift
+shift
+shift    
+
+pt=1
+lt=1
+
+for i in $* ; do
+    echo $i ;
+    echo $NAME
+    grep -A 1 $PAR1 $i | grep -v "\-\-" | grep -v "#" > $i.tmpplot.x ;
+    grep -A 1 $PAR2 $i | grep -v "\-\-" | grep -v "#" > $i.tmpplot.y ;
+    paste $i.tmpplot.x $i.tmpplot.y > $i.tmpplot ;
+    if test $i != $1 ; then echo -n ", ">>$FILE; fi
+    echo -n " "\"$i.tmpplot\"  title \"$NAME\" with $STYLE" " pt $pt >>$FILE ;
+    YPLOT="$YPLOT $i.tmpplot.y";
+    case $NAME in
+    A) NAME=B;;
+    B) NAME=C;;
+    C) NAME=D;;
+    D) NAME=E;;
+    E) NAME=F;;
+    F) NAME=G;;
+    esac;
+    let pt=$pt+1;
+done ;
+echo -n ", " 1.2*x*x*log\(x\)  title \"O\(k^2 log k\)\" with lines lt 2 " , " >>$FILE
+echo -n " " 0.05*x*log\(x\)  title \"O\(k log k\)\" with lines lt 3 " " >>$FILE
+echo >> $FILE
+paste $1.tmpplot.x $YPLOT | grep -v "#"
+
+cat $FILE
+gnuplot $FILE 
+rm -f $FILE
+rm -f *.tmpplot*
+