Index: GTP/trunk/Lib/Vis/Preprocessing/src/run_test2
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 1756)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 1756)
@@ -0,0 +1,85 @@
+#!/bin/sh
+
+#COMMAND="./release/preprocessor.exe -preprocessor_quit_on_finish+"
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+"
+
+#SCENE="../data/vienna/vienna-buildings.x3d;../data/vienna/vienna-roofs.x3d;../data/vienna/vienna-roads.x3d"
+#VIEWCELLS=../data/vienna/vienna-viewcells-5000.xml
+
+#SCENE=../data/soda/soda5.dat
+#VIEWCELLS=../data/soda/soda5-viewcells-1000.xml
+#VIEWCELLS=../data/soda/soda5-viewcells-single.xml
+
+#SCENE=../data/PowerPlant/selection.plb
+#VIEWCELLS=../data/PowerPlant/power_plant_viewcells1.xml
+
+#SCENE=../data/soda/soda.dat
+#VIEWCELLS=../data/soda/soda5-viewcells-1000.xml
+#VIEWCELLS=../data/soda/soda-viewcells-5000.xml
+#VIEWCELLS=../data/soda/soda5-viewcells-single.xml
+
+#SCENE=../data/artificial/city.x3d
+#VIEWCELLS=../data/soda/soda5-viewcells2.xml
+#VIEWCELLS=../data/artificial/city-viewcells-1000.xml
+
+#SCENE=../data/test1/test2.x3d
+#VIEWCELLS=../data/test1/test-viewcells.xml
+
+SCENE=../data/vienna/vienna_cropped.obj
+VIEWCELLS=../data/vienna/vienna_cropped-gradient-2-viewcells.xml.gz
+
+PREFIX=../work/plots/osp-rss
+
+#SCENE=../data/atlanta/atlanta2.x3d
+#PREFIX=../work/plots/atlanta2-rss9
+
+#$COMMAND -scene_filename=$SCENE -rss_use_importance+ -rss_update_subdivision-
+#mv stats.log $PREFIX-i-combined-b3.log
+
+# $COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+# -rss_use_importance+ -rss_update_subdivision+ -rss_split=regular \
+# -view_cells_filter_max_size=1
+ 
+# mv stats.log $PREFIX-i-combined-update-ccb3.log 
+
+# $COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+# -rss_use_importance+ -rss_update_subdivision+ -rss_split=heuristic \
+# -view_cells_filter_max_size=1
+ 
+# mv stats.log $PREFIX-i-combined-update-ccb4.log 
+
+$COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-view_cells_filter_max_size=1
+mv stats.log $PREFIX-r-reference.log 
+
+
+# $COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+# -rss_use_importance+ -rss_update_subdivision+ -rss_split=hybrid -hybrid_depth=10 \
+# -view_cells_filter_max_size=1
+# mv stats.log $PREFIX-i-combined-update-ccb12.log 
+
+
+
+# #######
+# #######
+# $COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+# -rss_use_importance- -rss_object_based_sampling- -rss_directional_sampling+ \
+# -view_cells_filter_max_size=1
+# mv stats.log $PREFIX-r-directional-based-b3.log
+
+
+# $COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+# -rss_use_importance- -rss_object_based_sampling- -rss_directional_sampling- \
+# -view_cells_filter_max_size=1
+# mv stats.log $PREFIX-r-spatial-based-bb3.log
+
+
+
+#$COMMAND -scene_filename=$SCENE -rss_use_importance- -rss_object_based_sampling- -rss_directional_sampling+
+#mv stats.log $PREFIX-r-direction-based-b3.log
+
+
+
+#-vss_samples=500000000
+
+
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 1744)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 1756)
@@ -1768,10 +1768,10 @@
 				   optBool,
 				   "preprocessor_apply_filter=",
-				   "true");
+				   "false");
 	
 	RegisterOption("Preprocessor.applyVisibilitySpatialFilter",
 				   optBool,
 				   "preprocessor_apply_spatial_filter=",
-				   "true");
+				   "false");
 
 	RegisterOption("Preprocessor.visibilityFilterWidth",
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1751)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1756)
@@ -2713,4 +2713,5 @@
 	  box.Enlarge(Vector3(radius));
 
+	  
 	  ObjectContainer objects;
 	  // $$ warning collect objects takes only unmailed ones!